#include "stdafx.h"
#include <tchar.h>
#include <strsafe.h>
#include <shellapi.h>
#include "tray.h"
#include "resource.h"

extern HINSTANCE hInstance;

HICON hIcon=NULL;
const TCHAR szProgTip[] = _T("Program Tip");

BOOL TrayMessage(HWND hDlg, DWORD dwMessage, UINT uID, HICON hIcon, TCHAR* pszTip)
{
    BOOL res;

	NOTIFYICONDATA tnd;

	tnd.cbSize		= sizeof(NOTIFYICONDATA);
	tnd.hWnd		= hDlg;
	tnd.uID			= uID;
    tnd.uFlags      = NIF_MESSAGE | NIF_ICON | NIF_TIP;
	tnd.uCallbackMessage	= MYWM_NOTIFYICON;
	tnd.hIcon		= hIcon;
	if (pszTip)
	{
		_tcsncpy_s(tnd.szTip, pszTip, sizeof(tnd.szTip));
	}
	else
	{
		tnd.szTip[0] = 0;
	}

	res = Shell_NotifyIcon(dwMessage, &tnd);

	return res;
}

void NotifyDelete(HWND hDlg, UINT uIndex)
{
	TrayMessage(hDlg, NIM_DELETE, uIndex, NULL, NULL);
}

void NotifyAdd(HWND hDlg, UINT uIndex)
{
	if( hIcon == NULL )
		hIcon = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(IDI_PROG), IMAGE_ICON, 16, 16, 0);

	TrayMessage(hDlg, NIM_ADD, uIndex, hIcon, (TCHAR*)szProgTip );
}

int ShowTrayMenu(HWND hWnd)
{
	HMENU hMenu, hSubMenu; 
	POINT pt; 
	
	hMenu = LoadMenu(hInstance, MAKEINTRESOURCE(PROGMENU)); 
	hSubMenu = GetSubMenu(hMenu, 0); 

	GetCursorPos(&pt); 
	
	SetForegroundWindow(hWnd); 
	
	TrackPopupMenu( hSubMenu, 0, pt.x, pt.y, 0, hWnd, NULL); 
    
	PostMessage(hWnd, WM_NULL, 0, 0);

	DestroyMenu(hMenu); 

	return 0;
}

LRESULT OnNotifyIcon( HWND hWnd, WPARAM wParam, LPARAM lParam )
{
	UINT uId;

    uId = (UINT)wParam;

	if( uId == 0 )
    {
		if( lParam == WM_RBUTTONUP )
			ShowTrayMenu(hWnd);
	}

    return 0;
}
