// mxplugin.cpp : DLL AvP[VpɃGNX|[g֐`܂B
//

#include "stdafx.h"
#include <tchar.h>
#include <strsafe.h>
#include <time.h>


//
// a sample code to unhide the target folder from the network access
// by granting the full folder access to the build-in user NETWORK
//
BOOL unhideFolder( const TCHAR* folderPath )
{
	PROCESS_INFORMATION pi;
	STARTUPINFO si;
	TCHAR wzPath[MAX_PATH*2];

	StringCchPrintfW( wzPath, MAX_PATH*2,
		L"cacls \"%s\" /t /e /g network:F",
		 folderPath );

	ZeroMemory(&si,sizeof(si));
	si.cb=sizeof(si);
	if( 0 != CreateProcess(NULL, wzPath,NULL,NULL,FALSE,NORMAL_PRIORITY_CLASS | CREATE_UNICODE_ENVIRONMENT | CREATE_NO_WINDOW,
							NULL,NULL,&si,&pi) )
	{
		CloseHandle(pi.hThread);
		WaitForSingleObject(pi.hProcess, 5000);
		CloseHandle(pi.hProcess);

		return TRUE;
	}

	return FALSE;
}

//
// a sample code to hide the target folder from the network access
// by denying the folder access to the build-in user NETWORK
//
BOOL hideFolder( const TCHAR* folderPath )
{
	PROCESS_INFORMATION pi;
	STARTUPINFO si;
	TCHAR wzPath[MAX_PATH*2];

	StringCchPrintfW( wzPath, MAX_PATH*2,
		L"cacls \"%s\" /t /e /d network",
		 folderPath );

	ZeroMemory(&si,sizeof(si));
	si.cb=sizeof(si);
	if( 0 != CreateProcess(NULL, wzPath,NULL,NULL,FALSE,NORMAL_PRIORITY_CLASS | CREATE_UNICODE_ENVIRONMENT | CREATE_NO_WINDOW,
							NULL,NULL,&si,&pi) )
	{
		CloseHandle(pi.hThread);
		WaitForSingleObject(pi.hProcess, 5000);
		CloseHandle(pi.hProcess);

		return TRUE;
	}

	return FALSE;

}

void writeLog( char* msg )
{
	HANDLE fHandle = CreateFile(
	  _T("C:\\Matrix\\mxconnect.txt"),            // t@C
	  GENERIC_WRITE,                              // ANZX[h
	  0,                                          // L[h
	  NULL,                                       // ZLeBLqq
	  OPEN_ALWAYS,                                // 쐬@
	  FILE_ATTRIBUTE_NORMAL,                      // t@C
	  NULL);									  // ev[gt@C̃nh

	if( fHandle == INVALID_HANDLE_VALUE )
		return;

	SetFilePointer( fHandle, 0, 0, FILE_END );

	DWORD written;

	WriteFile(fHandle, msg, (DWORD)strlen(msg), &written, NULL );

	CloseHandle( fHandle );
}

extern "C"
{

//
// this function is called when Matrix dongle is either plugged or unplugged
//
__declspec(dllexport) void WINAPI OnMxEvent(BOOL bConnected)
{
//#ifndef NDEBUG
	writeLog("OnMxEvent DLL\n");
//#endif

	// dongle is plugged in.
	if( bConnected == TRUE )
	{
		hideFolder(_T("c:\\matrix\\util"));
	}
	// dongle is unplugged
	else if( bConnected == FALSE )
	{
		unhideFolder(_T("c:\\matrix\\util"));
	}

}

//
// this function is called when the main program starts
//
__declspec(dllexport) BOOL WINAPI OnServiceStarted(void** winMsg)
{
//#ifndef NDEBUG
	writeLog("OnServiceStarted DLL\n");
//#endif

	// allocate UINT array
	*winMsg = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(UINT)*16); //new UINT[16];

	// set WinMsg routed to OnWinMsg
	((UINT*)(*winMsg))[0] = WM_CREATE;

	// the last element must be 0
	((UINT*)(*winMsg))[1] = 0;

	// if you do not wnat any WinMsg to be routed,
	// be sure to set winMsg to NULL
//	*winMsg = NULL;

	// returning FALSE will terminate the main program
	return TRUE;
}

//
// this function is called in WM_DESTROY,
// meaning there is no need to ask for WM_DESTROY routing
//
__declspec(dllexport) void WINAPI OnServiceStopped()
{
//#ifndef NDEBUG
	writeLog("OnServiceStopped  DLL\n");
//#endif

}

//
// code this API just like you code WndProc
//
__declspec(dllexport) LRESULT WINAPI OnWinMsg(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
//#ifndef NDEBUG
	char buf[256];
	sprintf_s( buf, 256, "OnWinMsg %lu  DLL\n", message );	
	writeLog(buf);
//#endif

	//
	// we asked for WM_CREATE only in OnServiceStarted
	// and this function is called only for WM_CREATE
	// in this sample
	//
	switch (message)
	{
		case WM_CREATE:
			break;
	}

	return 0;
}


//
// for Windows service only
// this function is called only when the main program runs as a Windows service
// When the main program runs as an application, set WM_WTSSESSION_CHANGE to be
// routed to OnWinMsg
//
__declspec(dllexport) void WINAPI OnSessionChange(DWORD sessionID, DWORD dwEventType)
{
//#ifndef NDEBUG
	char buf[256];
	sprintf_s( buf, 256, "OnSessionChanged %lu  DLL\n", dwEventType );
	writeLog(buf);
//#endif

		switch(dwEventType)
		{
			case WTS_SESSION_LOGON:
			case WTS_SESSION_LOGOFF:
			case WTS_CONSOLE_CONNECT:
			case WTS_REMOTE_CONNECT:
			case WTS_SESSION_UNLOCK:
			case WTS_SESSION_LOCK:
			case WTS_CONSOLE_DISCONNECT:
			case WTS_REMOTE_DISCONNECT:
				break;
		} // switch

}

//
// for Windows service only
// this function is called only when the main program runs as a Windows service
// when the main program is registered as a Windows service
//
__declspec(dllexport) void WINAPI OnServiceRegistered()
{
//#ifndef NDEBUG
	writeLog("OnServiceRegisterd  DLL\n");
//#endif

}

//
// for Windows service only
// this function is called only when the main program runs as a Windows service
// when it is removed as a Windows service 
//
__declspec(dllexport) void WINAPI OnServiceUnregistered()
{
//#ifndef NDEBUG
	writeLog("OnServiceUnregisterd  DLL\n");
//#endif

}

//
// for an application only
// this function is called only when the main program runs as an application program
// when it adds its tasy tray icon 
//
__declspec(dllexport) BOOL WINAPI OnNotifyAdd(HWND hWnd)
{
//#ifndef NDEBUG
	writeLog("OnNotifyAdd  DLL\n");
//#endif
	
	// be sure to return FALSE to use the default task tray icon/dialog
	return FALSE;
}

//
// for an application only
// this function is called only when the main program runs as an application program
// when it delete its tasy tray icon 
//
__declspec(dllexport) BOOL WINAPI OnNotifyDelete(HWND hWnd)
{
//#ifndef NDEBUG
	writeLog("OnNotifyDelete  DLL\n");
//#endif

	// be sure to return FALSE to use the default task tray icon/dialog
	return FALSE;
}

} // extern "C"

